## debian-installer 20100211ubuntu29

=== debian/changelog ===
debian-installer (20100211ubuntu29) maverick; urgency=low

  * Add input, NIC, and NFS modules to armel netboot images (LP: #652522).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 05 Oct 2010 22:01:29 +0100

debian-installer (20100211ubuntu28) maverick; urgency=low

  * No-change rebuild to pick up new components.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 28 Sep 2010 13:04:00 +0100

debian-installer (20100211ubuntu27) maverick; urgency=low

  * Move to 2.6.35-22 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 16 Sep 2010 14:28:25 +0100

debian-installer (20100211ubuntu26) maverick; urgency=low

  * Move to 2.6.35-21 kernels.
  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 13 Sep 2010 10:52:24 +0100

debian-installer (20100211ubuntu25) maverick; urgency=low

  * Move dove to 2.6.32-410 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 10 Sep 2010 17:01:31 +0100

debian-installer (20100211ubuntu24) maverick; urgency=low

  * Move to 2.6.35-20 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 05 Sep 2010 21:36:14 +0100

debian-installer (20100211ubuntu23) maverick; urgency=low

  * Disable imx51 armel flavour for now; linux-fsl-imx51 is no longer in the
    archive, and linux-linaro's i.MX51 support is still quite minimal
    according to Oliver Grawert and Loïc Minier.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Aug 2010 14:05:23 +0100

debian-installer (20100211ubuntu22) maverick; urgency=low

  * Move to 2.6.35-19 kernels.
  * Move dove to 2.6.32-409 kernels.
  * Add GRUB EFI configuration on amd64, and make mini.iso images there
    multi-catalog.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 27 Aug 2010 10:11:36 +0100

debian-installer (20100211ubuntu21) maverick; urgency=low

  * Move to 2.6.35-17 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 20 Aug 2010 16:46:17 +0100

debian-installer (20100211ubuntu20) maverick; urgency=low

  * Move to 2.6.35-16 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 18 Aug 2010 12:26:23 +0100

debian-installer (20100211ubuntu19) maverick; urgency=low

  * Move omap to 2.6.35-15 kernels, now that linux-ti-omap has been merged
    into linux.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 16 Aug 2010 22:27:31 +0100

debian-installer (20100211ubuntu18) maverick; urgency=low

  * Move to 2.6.35-15 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 16 Aug 2010 11:56:21 +0100

debian-installer (20100211ubuntu17) maverick; urgency=low

  * Move to 2.6.35-14 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 02 Aug 2010 11:12:28 -0500

debian-installer (20100211ubuntu16) maverick; urgency=low

  * Move to 2.6.35-13 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 01 Aug 2010 09:40:17 -0500

debian-installer (20100211ubuntu15) maverick; urgency=low

  * Move to 2.6.35-10 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 22 Jul 2010 22:29:58 +0100

debian-installer (20100211ubuntu14) maverick; urgency=low

  * Move to 2.6.35-9 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 19 Jul 2010 11:39:07 +0100

debian-installer (20100211ubuntu13) maverick; urgency=low

  * Move to 2.6.35-8 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 15 Jul 2010 11:37:30 +0100

debian-installer (20100211ubuntu12) maverick; urgency=low

  * Support building with new apt mirror method.
  * Move to 2.6.35-7 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 08 Jul 2010 11:54:29 +0100

debian-installer (20100211ubuntu11) maverick; urgency=low

  * vga=788 seems to work now that vesafb and fbcon are built into the
    kernel, and it's very much faster in kvm, so resync with Debian and use
    it.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Jun 2010 17:44:51 +0100

debian-installer (20100211ubuntu10) maverick; urgency=low

  * Move to 2.6.35-6 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 25 Jun 2010 16:18:07 +0100

debian-installer (20100211ubuntu9) maverick; urgency=low

  * Argh.  It's console-setup-udeb, not console-setup.
  * Move to 2.6.35-5 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 22 Jun 2010 12:06:15 +0100

debian-installer (20100211ubuntu8) maverick; urgency=low

  * More console-setup fixes for armel.
  * Remove a few last vestiges of lpia.
  * Move to 2.6.35-4 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 17 Jun 2010 12:33:24 +0100

debian-installer (20100211ubuntu7) maverick; urgency=low

  * Switch to console-setup keymaps on armel, to match other architectures.
  * Increase the powerpc netboot image size a bit more, to 20MB.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 11 Jun 2010 12:25:44 +0100

debian-installer (20100211ubuntu6) maverick; urgency=low

  * Move to 2.6.35-2 kernels.
  * Drop dns323-firmware-tools build-dependency on armel; this is only for
    orion5x, which we don't build.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 09 Jun 2010 17:32:37 +0100

debian-installer (20100211ubuntu5) maverick; urgency=low

  * Move to 2.6.35-1 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 07 Jun 2010 17:40:23 +0100

debian-installer (20100211ubuntu4) maverick; urgency=low

  * Remove dtmenu.cfg from default menu.cfg; it isn't used in Ubuntu and it
    confuses gfxboot-theme-ubuntu (LP: #588221).

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 01 Jun 2010 12:34:05 +0100

debian-installer (20100211ubuntu3) maverick; urgency=low

  * Move to 2.6.34-5 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 31 May 2010 07:52:29 +0200

debian-installer (20100211ubuntu2) maverick; urgency=low

  * Move to 2.6.34-4 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 26 May 2010 14:08:09 +0100

debian-installer (20100211ubuntu1) maverick; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Ubuntu branding of various kinds.
    - Use Ubuntu kernels.  Various tweaks for different udeb splits.
    - Fetch distribution name and version number from lsb_release.


=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Maintainer: Ubuntu Installer Team <ubuntu-installer@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Joey Hess <joeyh@debian.org>, Frans Pop <fjp@debian.org>, Otavio Salvador <otavio@debian.org>
Standards-Version: 3.8.3
XS-Debian-Vcs-Svn: svn://svn.debian.org/d-i/trunk/installer
Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/debian-installer/ubuntu
Build-Conflicts: libnewt-pic [mipsel]
# NOTE: Do not edit the next line by hand. See comment below.
Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc], hfsutils [powerpc], dosfstools [i386 ia64 m68k amd64], cpio, devio [armeb armel], slugimage (>= 0.10+r58-6) [armeb armel], uboot-mkimage [armel], redboot-tools (>= 0.6) [arm armel], syslinux (>= 2:3.63+dfsg-2) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc], genisovh [mips], tip22 [mips], colo [mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], redboot-imx51-babbage [arm armel], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sparc], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-rescue-efi-amd64 [amd64], grub-common [amd64]
# This package has the worst Build-Depends in Debian, so it deserves some
# explanation. Note that this comment can also be used to generate a
# Build-Depends line, by running the debian/genbuilddeps program.
# So put each build dep on its own line, prefixed by " - " and to
# comment out a build dep, start the line with two hashes. And don't edit
# the Build-Depends line above by hand.
#
# Base build dependencies:
#	- debhelper (>= 7.0.0)
#		Of course.
# 	- apt
# 		Used for downloading udebs.
# 	- apt-utils
# 		apt-ftparchive is used for including localudebs.
#	- gnupg
#		New versions of apt need gnupg for security checks.
#	- ubuntu-keyring
#		To provide the archive key for security checks.
#	- dctrl-tools
#		Various manipulations of the udeb Packages files.
#	- wget
#		Used to test validity of mirrors.
#	- bc
#		Used for some image size calculations.
#	- debiandoc-sgml
#		partman's manual is in debiandoc.
#	- xsltproc
#	- docbook-xml
#	- docbook-xsl
#		The d-i internals manual is in DocBook XML.
#	- libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386]
#		For bdftobogl used in font reduction.
#	- lsb-release
#		Provides system version information.
#	
# Library build dependencies:
#	- glibc-pic
#		For library reduction.
#	- libslang2-pic (>= 2.0.6-4)
#		Make dependency versioned temporarily to make sure we avoid #392942
#	- libnewt-pic (>= 0.52.2-11.3) [!mipsel]
#		Rather than use slang and newt udebs, reduced versions of
#		the libraries are put onto images to save space.
#	- libnewt-dev (>= 0.52.2-11.3) [mipsel]
#		On mipsel, we can't use libnewt-pic right now due to bug
#		#329733. See also Build-Conflicts above.
#	- libgcc1 [i386 amd64]
#		On x86 we need to include /lib/libgcc_s.so.1 in g-i initrds to
#		work around #373253 until upstream can remove pthread_cancel()
#		On i386 
#		calls in directfb. For now, this is done by setting EXTRAFILES.
#
# Filesystem tools:
#	- cramfsprogs [powerpc ia64 mips mipsel armeb armel]
#		For arches that use cramfs initrds.
#	- genext2fs (>= 1.3-7.1)
#		For creating ext2 filesystems without being root.
#		1.3-7.1 fixes issues on several arches.
#	- e2fsprogs
#		genext2fs doesn't produce perfect filesystems, so we fsck
#		them.
#		Lintian: Yes, we know it's essential. We prefer not to
#		count on it remaining so.
#	- mklibs (>= 0.1.25)
#		We use mklibs for library reduction.
#	- genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x]
#		For making mini isos.
#	- genromfs [sparc]
#		Used for creating sparc floppies (which are not built by
#		default.)
#	- hfsutils [powerpc]
#		For making bootable HFS USB sticks for powerpc.
#	- dosfstools [i386 ia64 m68k amd64]
#		For creating FAT filesystems with mkfs.msdos.
#		Of course i386/amd64 use this for floppies, CDs etc.
#		ia64 uses it for floppies (?)
#		m68k uses it for atari floppies
#	- cpio
#		For creating initramfs images.
#	- devio [armeb armel]
#		Tool to read and write from block devices, used to byteswap
#		kernels and add nslu2 boot magic.
#	- slugimage (>= 0.10+r58-6) [armeb armel]
#		For building nslu2 firmware images.
#	- uboot-mkimage [armel]
#		For creating u-boot images
#	- redboot-tools (>= 0.6) [arm armel]
#		For creating redboot SD card images for imx51 babbage boards
#
# Boot loaders:
#	On many arches boot loaders are copied onto or ran on the boot
#	images in one way or another. There's a reason our mailing list is
#	still called debian-boot..
#	- syslinux (>= 2:3.63+dfsg-2) [i386 amd64]
#		With menu default64 support.		
#	- palo [hppa]
#	- elilo [ia64]
#	- yaboot [powerpc]
#		For all our powerpc boot needs. Well, not really.
#	- aboot (>= 0.9b-2) [alpha]
#		A previous version didn't have netabootwrap.
#	- silo [sparc]
#		Using silo is problimatic since it needs to run as root,
#		so images that need it are not built by default, but we
#		include it for completeness.
#	- sparc-utils [sparc]
#		For elftoaout and piggyback, to make netboot images.
#	- genisovh [mips]
#		Makes mini iso images bootable on SGI MIPSen.
#	- tip22 [mips]
#		Piggyback netboot images.
#	- colo [mipsel]
#		For booting Cobalt machines.
#	- atari-bootstrap [m68k]
#		Booting and other tools for Atari systems.
#	- vmelilo [m68k]
#	- m68k-vme-tftplilo [m68k]
#		For VME machines, although it doesn't yet support running
#		as non-root, the install will try to use it and fall back
#		to a warning when it fails.
#	- amiboot [m68k]
#		Bootloader for m68k/amiga machines.
#	- emile [m68k]
#	- emile-bootblocks [m68k]
#		Bootloader for m68k/mac machines.
#	- redboot-imx51-babbage [arm armel]
#		Redboot bootloader binaries for SD card images for imx51
#
# Architecture specific build dependencies:
#	- tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64]
#		For todos, used on files that need to be accessible from
#		DOS.
#	- mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386]
#		mcopy is used to put files onto FAT filesystems w/o
#		mounting them.
#	- po4a [i386 amd64]
#	- python [i386 amd64]
#		For building gfxboot help texts.
#
#	- module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sparc]
#		depmod for 2.6 kernels on the arches that support 2.6.
#
#	- bf-utf-source [!s390 !s390x]
#		Contains the unicode font we use. Not a udeb since we
#		perform font reduction at build time.
#	- mkvmlinuz [powerpc]
#		Used to make powerpc images that can boot direct from
#		firmware w/o using a boot loader.
#	- openssl [armel]
#		Used to encrypt a firmware image so an ARM based device
#		(Thecus N2100) will accept it.
#	- makefs [kfreebsd-i386 kfreebsd-amd64]
#		Used to create an UFS1 filesystem from a directory tree.
#	- grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386]
#		Used as the CD-ROM's bootloader
#	- grub-rescue-efi-amd64 [amd64]
#		EFI bootloader support.
#	- grub-common [amd64]
#		For the GRUB font.

Package: debian-installer
Architecture: any
Description: Debian installer
 This package currently only contains some documentation for the Debian
 installer. We welcome suggestions about what else to put in it.

## debian-installer 20100211ubuntu29.3

=== build/Makefile ===
#!/usr/bin/make -f
#
# Debian Installer system makefile.
# Copyright 2001-2003 by Joey Hess <joeyh@debian.org> and the d-i team.
# Licensed under the terms of the GPL.
#
# This makefile builds a debian-installer system and bootable images from 
# a collection of udebs which it downloads from a Debian archive. See
# README for details.
#
#
# General layout of our build directory hierarchy
#
# build/config/[<subarch>/][<medium>/][<flavour>/]<leaf-config>
# build/tmp/[<subarch>/][<medium>/][<flavour>/]<build-area>
# build/dest/[<subarch>/][<medium>/][<flavour>-]<images>
#
# Items in brackets can be left out if they are superfluous.
#
# These following <image> names are conventional.
#
# For small changeable media (floppies and the like):
# - boot.img, root.img, driver.img
#
# For single bootable images (e.g. tftp boot images):
# - boot.img
#
# For compressed single bootable images (harddisk or hd emulation):
# - boot.img.gz
#
# If those are not bootable:
# - root.img.gz
#
# Raw kernel images:
# - vmlinux or vmlinuz
#
# Example:
#
# dest/
# |-- cdrom-boot.img
# |-- floppy
# |   |-- access
# |   |   |-- boot.img
# |   |   |-- drivers.img
# |   |   `-- root.img
# |   |-- boot.img
# |   |-- cd-drivers.img
# |   |-- net-drivers.img
# |   `-- root.img
# |-- hd-media-boot.img.gz
# `-- netboot
#     |-- initrd.gz
#     `-- vmlinuz
#

# Add to PATH so dpkg will always work, and so local programs will be found.
PATH := util:$(PATH):/usr/sbin:/sbin

# We don't want this to be run each time we re-enter.
ifndef DEB_HOST_ARCH
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
export DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_CPU DEB_HOST_GNU_SYSTEM
endif

# We loop over all needed combinations of ARCH, SUBARCH, MEDIUM, FLAVOUR
# via recursive make calls. ARCH is constant, we don't support
# crosscompiling.
ARCH = $(DEB_HOST_ARCH)

# By default, we just advertise what we can do.
.PHONY: all
all: list

# Globally useful variables.
targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
targetdirs = $(subst _,/,$(targetstring))


# Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
# For simplicity, we use a similiar tree layout for config/, tmp/
# and dest/.
#
# Cheap trick: if one of the variables isn't defined, we run in
# a non-existing file and ignore it.
include config/common
include config/dir
-include config/$(ARCH).cfg
-include config/$(ARCH)/$(SUBARCH).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM)/$(FLAVOUR).cfg
-include config/local

export KEYRING
export KERNELVERSION

ifneq ($(shell id -u),0)
  ROOTCMD ?= fakeroot
endif

# Useful command sequences
define submake
  $(ROOTCMD) $(MAKE) --no-print-directory
endef

define recurse_once
  @set -e; $(submake) $(1)_$(2)
endef

define recurse_many
  @set -e; $(foreach var,$($(1)_SUPPORTED) $(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(submake) $(2)_$(3) $(1)=$(var);)
endef

define recurse
  $(if $($(1)_SUPPORTED)$(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
endef

define genext2fs
  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
endef

define mkinitramfs
  (cd $(TREE) && find . | cpio --quiet -o -H newc) > 
endef

define mkfs.ufs1
  sh -c 'makefs -t ffs -s 30m -f 1000 -o minfree=0,version=1 $$0 ${TREE}'
endef

define e2fsck
  e2fsck -fy
endef

define mkcramfs
  mkcramfs -z $(TREE)
endef

# Define MKFS_JFFS2 in the config file for your target.
# For example: MKFS_JFFS2 = mkfs.jffs2 -f -p -b -e 0x20000
define mkjffs2
  $(MKFS_JFFS2) -d $(TREE) -o
endef

# A generic recursion rule
.PHONY: all_%
all_%:
	@install -d $(STAMPS)
	$(call recurse,SUBARCH,subarch,$*)

.PHONY: subarch_%
subarch_%:
	$(call recurse,MEDIUM,medium,$*)

.PHONY: medium_%
medium_%:
	$(call recurse,FLAVOUR,flavour,$*)

.PHONY: flavour_%
flavour_%:
	$(if $(targetstring),@$(submake) _$*)

# Validate a targetstring, echo env variables for valid ones
.PHONY: validate_%
validate_%:
	@set -e; \
	SUBARCH= var='$(subst _, ,$(subst validate_,,$@))'; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(SUBARCH_SUPPORTED)$(SUBARCH_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(SUBARCH_SUPPORTED) $(SUBARCH_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || SUBARCH=$$tmp; \
	$(submake) medium_validate SUBARCH=$$SUBARCH var="$$var"

.PHONY: medium_validate
medium_validate:
	@set -e; \
	MEDIUM= var="$(strip $(patsubst $(SUBARCH)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(MEDIUM_SUPPORTED)$(MEDIUM_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(MEDIUM_SUPPORTED) $(MEDIUM_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || MEDIUM=$$tmp; \
	$(submake) flavour_validate MEDIUM=$$MEDIUM var="$$var"

.PHONY: flavour_validate
flavour_validate:
	@set -e; \
	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"

.PHONY: finish_validate
finish_validate:
	@set -e; \
	var="$(strip $(patsubst $(FLAVOUR)%,%,$(var)))"; \
	if [ -z "$$var" ]; then \
		echo SUBARCH=$$SUBARCH MEDIUM=$$MEDIUM FLAVOUR=$$FLAVOUR; \
	else \
		echo SUBARCH= MEDIUM= FLAVOUR=; \
	fi;


# List all targets useful for direct invocation.
.PHONY: list
list:
	@echo "Useful targets:"
	@echo
	@echo "list"
	@echo "all_build"
	@echo "all_rebuild"
	@echo "stats"
	@echo "all_clean"
	@echo "reallyclean"
	@echo
	@$(submake) all_list RECURSE_EXTRA=1

.PHONY: _list
_list:
	@set -e; \
	echo build_$(targetstring); \
	echo stats_$(targetstring); \
	$(if $(findstring $(MEDIUM),$(WRITE_MEDIA)),echo write_$(targetstring);) \
	echo clean_$(targetstring); \
	echo rebuild_$(targetstring); \
	echo demo_$(targetstring); \
	echo shell_$(targetstring); \
	echo uml_$(targetstring); \
	echo qemu_$(targetstring); \
	echo


# Clean all targets.
.PHONY: reallyclean
reallyclean: all_clean
	rm -rf $(APTDIR) $(APTDIR).udeb $(APTDIR).deb $(BASE_DEST) $(BASE_TMP) $(SOURCEDIR) $(DEBUGUDEBDIR)
	rm -f sources.list sources.list.udeb $(LOCALUDEBDIR)/Packages.gz $(LOCALUDEBDIR)/Packages
	rm -rf $(UDEBDIR) $(STAMPS)

# For manual invocation, we provide a generic clean rule.
.PHONY: clean_%
clean_%:
	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
	update-manifest

# The general clean rule.
.PHONY: _clean
_clean: tree_umount
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	-rm -f $(STAMPS)tree-unpack-$(targetstring)-stamp $(STAMPS)tree-$(targetstring)-stamp $(STAMPS)extra-$(targetstring)-stamp $(STAMPS)get_udebs-$(targetstring)-stamp
	rm -f $(TEMP)/diskusage.txt
	rm -f $(TEMP)/all.utf
	rm -f $(TEMP)/unifont.bdf $(TREE)/lib/unifont.bgf
	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
	rm -rf $(TARGET)
	rm -rf $(TEMP)

# all_build is provided automagically, but for manual invocation
# we provide a generic build rule.
.PHONY: build_%
build_%:
	@install -d $(STAMPS)
	@$(submake) _build $(shell $(submake) $(subst build_,validate_,$@))

# The general build rule.
.PHONY: _build
_build:
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)

# Convenience rules to clean and build.
.PHONY: rebuild_%
rebuild_%:
	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)

.PHONY: _rebuild
_rebuild:
	@$(submake) _clean _build

# Run before releasing built files.
release:
	egrep '^[[:space:]]' $(BASE_DEST)/MANIFEST.udebs | \
		sed 's/^[[:space:]]*//' | sort | uniq > $(BASE_DEST)/udeb.list
	rm -f $(BASE_DEST)/MD5SUMS $(BASE_DEST)/SHA1SUMS $(BASE_DEST)/SHA256SUMS
	cd $(BASE_DEST) && md5sum `find . -type f` > MD5SUMS
	cd $(BASE_DEST) && sha1sum `find . -type f` > SHA1SUMS
	cd $(BASE_DEST) && sha256sum `find . -type f` > SHA256SUMS

# The general tree target.
$(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
	dh_testroot
	cd .. && dpkg-checkbuilddeps
	@rm -f $@

	# This build cannot be restarted, because dpkg gets confused.
	rm -rf $(TREE)
	# Set up the basic files [u]dpkg needs.
	mkdir -p $(DPKGDIR)/info
	touch $(DPKGDIR)/status
	# Create a tmp tree
	mkdir -p $(TREE)/tmp
	# Only dpkg needs this stuff, so it can be removed later.
	mkdir -p $(DPKGDIR)/updates/
	touch $(DPKGDIR)/available

ifdef TRANSSTATUS
	# Include translation status file; warn if older than 2 weeks.
	# Do this first to make possible warnings more visible.
	@echo; \
	if [ -f "$(TRANSSTATUS)" ]; then \
		olddate=$$(grep "^# Generated on:" $(TRANSSTATUS) | sed "s/.*: //"); \
		if [ "$$olddate" ]; then \
			if [ $$(( $$(date -u "+%s") - \
			          $$(date -d "$$olddate" "+%s") \
			       )) -gt 1209600 ]; then \
				echo "WARNING: The data in '$(TRANSSTATUS)' is older than 2 weeks."; \
				echo "         Should it maybe be updated?"; \
				sleep 15; \
			fi; \
		else \
			echo "WARNING: no timestamp found in $(TRANSSTATUS)."; \
			sleep 15; \
		fi; \
		mkdir -p $(TREE)/usr/share/localechooser; \
		cp $(TRANSSTATUS) $(TREE)/usr/share/localechooser/translation-status; \
	else \
		echo "WARNING: the file $(TRANSSTATUS) does not exist."; \
		sleep 5; \
	fi
endif

	# Unpack the udebs with dpkg. This command must run as root
	# or fakeroot.
	echo -n > $(TEMP)/diskusage.txt
	set -e; \
	oldsize=0; oldblocks=0; oldcount=0; for udeb in $(UDEBDIR)/*.udeb ; do \
		if [ -f "$$udeb" ]; then \
			pkg=`basename $$udeb` ; \
			dpkg $(DPKG_UNPACK_OPTIONS) --log=/dev/null --root=$(TREE) --unpack $$udeb ; \
			newsize=`du -bs $(TREE) | awk '{print $$1}'` ; \
			newblocks=`du -s $(TREE) | awk '{print $$1}'` ; \
			newcount=`find $(TREE) -type f | wc -l | awk '{print $$1}'` ; \
			usedsize=`echo $$newsize - $$oldsize | bc`; \
			usedblocks=`echo $$newblocks - $$oldblocks | bc`; \
			usedcount=`echo $$newcount - $$oldcount | bc`; \
			version=`dpkg-deb --info $$udeb | grep '^ *Version:' | sed 's/^ *//' | awk '{print $$2}'` ; \
			echo " $$usedsize B - $$usedblocks blocks - $$usedcount files from $$pkg (version $$version)" >>$(TEMP)/diskusage.txt;\
			oldsize=$$newsize ; \
			oldblocks=$$newblocks ; \
			oldcount=$$newcount ; \
		fi; \
	done
	sort -n < $(TEMP)/diskusage.txt > $(TEMP)/diskusage.txt.new && \
		mv $(TEMP)/diskusage.txt.new $(TEMP)/diskusage.txt
	grep-dctrl -nsPackage,Version,Architecture '' $(TREE)/var/lib/dpkg/status | \
		perl -nle '$$p = $$_; $$v = <>; chomp $$v; $$a = <>; chomp $$a; <>; print "$$p $$v $$a"' | \
		sort > $(TEMP_UDEB_LIST)

	# Clean up after dpkg.
	rm -rf $(DPKGDIR)/updates
	rm -f $(DPKGDIR)/available $(DPKGDIR)/*-old $(DPKGDIR)/lock

ifdef EXTRAFILES
	# Copy in any extra files.
	set -e; \
	for file in $(EXTRAFILES); do \
		mkdir -p $(TREE)/`dirname $$file`; \
		cp -a $$file $(TREE)/$$file; \
	done
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
ifdef KERNELVERSION
	# Set up modules.dep, ensure there is at least one standard dir (kernel
	# in this case), so depmod will use its prune list for archs with no
	# modules.
	set -e; \
	$(foreach VERSION,$(KERNELVERSION), \
		sysmap_name=; sysmap_opt=; \
		if [ -n "$(VERSIONED_SYSTEM_MAP)" ]; then \
			[ ! -e $(TREE)/boot/System.map-$(VERSION) ] || sysmap_name="$(TREE)/boot/System.map-$(VERSION)"; \
		else \
			[ ! -e $(TREE)/boot/System.map ] || sysmap_name="$(TREE)/boot/System.map"; \
		fi; \
		[ -z "$$sysmap_name" ] || sysmap_opt="-F $$sysmap_name"; \
		if [ -d $(TREE)/lib/modules/$(VERSION) ] && [ -z "$(OMIT_DEPMOD)" ]; then \
			mkdir -p $(TREE)/lib/modules/$(VERSION)/kernel; \

=== debian/changelog ===
debian-installer (20100211ubuntu29.3) maverick-proposed; urgency=low

  * Move to 2.6.35-30 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Aug 2011 18:13:33 +0100

debian-installer (20100211ubuntu29.2) maverick-proposed; urgency=low

  * Use udebs from maverick-security, maverick-proposed, and
    maverick-updates.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 24 Nov 2010 10:38:31 +0000

debian-installer (20100211ubuntu29.1) maverick-proposed; urgency=low

  * Move to 2.6.35-23 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Nov 2010 16:15:08 +0000

=== debian/rules ===
#! /usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2 | cut -d - -f 1)
ifeq (${SUITE},UNRELEASED)
USE_UDEBS_FROM=maverick
TRANSSTATUS=
BOOTMENU_BEEP=n
else
USE_UDEBS_FROM=$(SUITE)
USE_PROPOSED_UPDATES=0
TRANSSTATUS=translation-status
BOOTMENU_BEEP=y
endif

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(VERSION)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean
	$(MAKE) -C doc/devel/internals clean

# Must run as root, so is not run as part of regular build.
build-images:
	$(MAKE) -C build all_build stats release \
		USE_UDEBS_FROM=$(USE_UDEBS_FROM) BUILD_DATE=$(DATE) \
		USE_PROPOSED_UPDATES=$(USE_PROPOSED_UPDATES) \
		TRANSSTATUS=$(TRANSSTATUS) BOOTMENU_BEEP=$(BOOTMENU_BEEP)
	
build: build-stamp
build-stamp:
	rm -f $@
	$(MAKE) -C doc/devel/internals
	$(MAKE) -C doc/devel/partman
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	ln -s $(VERSION) $(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/* -X Makefile -X build.sh -X .xsl \
		-X internals.xml -X partman-doc.sgml
	dh_compress
	dh_fixperms
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	cd debian/tmp && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) raw-installer -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build build-images clean binary-indep binary-arch binary install

## debian-installer 20101020ubuntu29

=== debian/changelog ===
debian-installer (20101020ubuntu29) natty; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 21 Apr 2011 01:01:08 +0100

debian-installer (20101020ubuntu28) natty; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 11 Apr 2011 18:01:35 +0100

debian-installer (20101020ubuntu27) natty; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 07 Apr 2011 23:13:15 +0100

debian-installer (20101020ubuntu26) natty; urgency=low

  * Move to 2.6.38-8 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 05 Apr 2011 16:47:33 +0100

debian-installer (20101020ubuntu25) natty; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 01 Apr 2011 18:28:08 +0100

debian-installer (20101020ubuntu24) natty; urgency=low

  * Skip the option field in sources.list lines, if present.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Mar 2011 18:05:33 +0100

debian-installer (20101020ubuntu23) natty; urgency=low

  * Fix "F19" typo in gfxboot help text (LP: #537894).
  * Move to 2.6.38-7 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Mar 2011 11:36:32 +0000

debian-installer (20101020ubuntu22) natty; urgency=low

  * Move to 2.6.38-6 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 09 Mar 2011 23:07:16 +0000

debian-installer (20101020ubuntu21) natty; urgency=low

  * Install /var/lib/dpkg/info/$(dpkg --print-architecture) -> . symlink so
    that images build correctly in the presence of multiarch dpkg.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 01 Mar 2011 13:17:29 +0000

debian-installer (20101020ubuntu20) natty; urgency=low

  * Stop building the armel dove subarchitecture; it no longer has a kernel
    in natty.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 01 Mar 2011 10:33:01 +0000

debian-installer (20101020ubuntu19) natty; urgency=low

  * Include biosdevname-udeb on architectures where it's available.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 28 Feb 2011 21:26:29 +0000

debian-installer (20101020ubuntu18) natty; urgency=low

  * No-change rebuild against udev-udeb 166-0ubuntu2.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 24 Feb 2011 14:43:20 +0000

debian-installer (20101020ubuntu17) natty; urgency=low

  * Move to 2.6.38-5 kernels.

 -- Andy Whitcroft <apw@canonical.com>  Wed, 23 Feb 2011 13:54:43 +0000

debian-installer (20101020ubuntu16) natty; urgency=low

  * Move to 2.6.38-4 kernels.

 -- Andy Whitcroft <apw@canonical.com>  Fri, 18 Feb 2011 12:22:31 +0000

debian-installer (20101020ubuntu15) natty; urgency=low

  * Move to 2.6.38-3 kernels.

 -- Andy Whitcroft <apw@canonical.com>  Thu, 10 Feb 2011 21:41:26 +0000

debian-installer (20101020ubuntu14) natty; urgency=low

  * Move to 2.6.38-2 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 08 Feb 2011 15:02:05 +0000

debian-installer (20101020ubuntu13) natty; urgency=low

  * Move to 2.6.38-1 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 28 Jan 2011 09:38:24 +0000

debian-installer (20101020ubuntu12) natty; urgency=low

  * switch build-deps from u-boot to u-boot-tools

 -- Oliver Grawert <ogra@ubuntu.com>  Fri, 07 Jan 2011 13:26:46 +0100

debian-installer (20101020ubuntu11) natty; urgency=low

  * Move to 2.6.37-12 kernels.

 -- Andy Whitcroft <apw@canonical.com>  Thu, 06 Jan 2011 23:21:18 +0000

debian-installer (20101020ubuntu10) natty; urgency=low

  [ Loïc Minier ]
  * Build-depend on u-boot [armel] rather than uboot-mkimage [armel] as
    mkimage moved to this package in natty.
  
  [ Michael Vogt ]
  * Move to 2.6.37-11 kernels.

 -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 22 Dec 2010 15:10:59 +0100

debian-installer (20101020ubuntu9) natty; urgency=low

  * Move to 2.6.37-10 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 17 Dec 2010 14:35:25 +0000

debian-installer (20101020ubuntu8) natty; urgency=low

  * Move to 2.6.37-9 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 13 Dec 2010 10:58:21 +0000

debian-installer (20101020ubuntu7) natty; urgency=low

  * Move to 2.6.37-8 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 06 Dec 2010 16:49:58 +0000

debian-installer (20101020ubuntu6) natty; urgency=low

  * No-change rebuild to pick up new kernel.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 01 Dec 2010 10:38:20 +0000

debian-installer (20101020ubuntu5) natty; urgency=low

  * Move to 2.6.37-7 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 29 Nov 2010 14:32:05 +0000

debian-installer (20101020ubuntu4) natty; urgency=low

  * Move to 2.6.37-6 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 23 Nov 2010 19:14:25 +0000

debian-installer (20101020ubuntu3) natty; urgency=low

  * Move to 2.6.37-5 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 18 Nov 2010 01:46:35 +0000

debian-installer (20101020ubuntu2) natty; urgency=low

  * Backport from trunk:
    - geniso_hybrid_plus_firmware_partition: Cope if the disk size exceeds
      32MB.  (The previous code seems to have misunderstood isohybrid's
      defaults slightly, but we now just specify the full CHS geometry
      explicitly in case anything changes in the future.)
  * Move to 2.6.37-4 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 16 Nov 2010 13:55:49 +0000

debian-installer (20101020ubuntu1) natty; urgency=low

  * Resynchronise with Debian.  Remaining changes:
    - Ubuntu branding of various kinds.
    - Use Ubuntu kernels.  Various tweaks for different udeb splits.
    - Fetch distribution name and version number from lsb_release.
    - Use the full version number in image directories.
    - Various boot screen text adjustments.
    - Add cli boot options.
    - Add memtest boot option.
    - Add live CD boot screens.
    - Adjust memory size recommendations.
    - Document pci=noacpi.
    - Add translatable boot screen text for gfxboot.  Adjust existing text


=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
 SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2 | cut -d - -f 1)
 ifeq (${SUITE},UNRELEASED)
-USE_UDEBS_FROM=maverick
+USE_UDEBS_FROM=natty
 TRANSSTATUS=
 BOOTMENU_BEEP=n
 else

## debian-installer 20101020ubuntu29.2

=== build/Makefile ===
--- 
+++ 
@@ -78,6 +78,10 @@
 targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
 targetdirs = $(subst _,/,$(targetstring))
 
+# Overridden in config/hurd.cfg
+define genext2fs
+  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
+endef
 
 # Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
 # For simplicity, we use a similiar tree layout for config/, tmp/
@@ -95,6 +99,7 @@
 
 export KEYRING
 export KERNELVERSION
+export LOCALUDEBDIR
 
 ifneq ($(shell id -u),0)
   ROOTCMD ?= fakeroot
@@ -117,16 +122,12 @@
   $(if $($(1)_SUPPORTED)$(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
 endef
 
-define genext2fs
-  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
-endef
-
 define mkinitramfs
   (cd $(TREE) && find . | cpio --quiet -o -H newc) > 
 endef
 
 define mkfs.ufs1
-  sh -c 'makefs -t ffs -s 30m -f 1000 -o minfree=0,version=1 $$0 ${TREE}'
+  sh -c 'makefs -t ffs -s 42m -f 3000 -o minfree=0,version=1 $$0 ${TREE}'
 endef
 
 define e2fsck
@@ -183,7 +184,7 @@
 	@set -e; \
 	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
 	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
-	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
+	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) | grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
 	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"
 
 .PHONY: finish_validate
@@ -285,6 +286,7 @@
 # The general tree target.
 $(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
 	dh_testroot
+	@[ -d ../debian ] || { echo "directory '../debian' not found; complete source of 'debian-installer' package is required"; false; }
 	cd .. && dpkg-checkbuilddeps
 	@rm -f $@
 
@@ -292,6 +294,7 @@
 	rm -rf $(TREE)
 	# Set up the basic files [u]dpkg needs.
 	mkdir -p $(DPKGDIR)/info
+	ln -nsf . $(DPKGDIR)/info/$(shell dpkg --print-architecture)
 	touch $(DPKGDIR)/status
 	# Create a tmp tree
 	mkdir -p $(TREE)/tmp
@@ -378,6 +381,3 @@
 		else \
 			[ ! -e $(TREE)/boot/System.map ] || sysmap_name="$(TREE)/boot/System.map"; \
 		fi; \
-		[ -z "$$sysmap_name" ] || sysmap_opt="-F $$sysmap_name"; \
-		if [ -d $(TREE)/lib/modules/$(VERSION) ] && [ -z "$(OMIT_DEPMOD)" ]; then \
-			mkdir -p $(TREE)/lib/modules/$(VERSION)/kernel; \

=== debian/changelog ===
debian-installer (20101020ubuntu29.2) natty-proposed; urgency=low

  * Move to 2.6.38-15 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 04 Jul 2012 10:06:23 +0100

debian-installer (20101020ubuntu29.1) natty-proposed; urgency=low

  * Use udebs from natty-security, natty-proposed, and natty-updates.
  * Move to 2.6.38-11 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 26 Sep 2011 22:10:42 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Ubuntu Installer Team <ubuntu-installer@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
-Uploaders: Joey Hess <joeyh@debian.org>, Frans Pop <fjp@debian.org>, Otavio Salvador <otavio@debian.org>
+Uploaders: Frans Pop <fjp@debian.org>, Otavio Salvador <otavio@debian.org>
 Standards-Version: 3.8.3
 XS-Debian-Vcs-Svn: svn://svn.debian.org/d-i/trunk/installer
 Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/debian-installer/ubuntu
 Build-Conflicts: libnewt-pic [mipsel]
 # NOTE: Do not edit the next line by hand. See comment below.
-Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc], hfsutils [powerpc], dosfstools [i386 ia64 m68k amd64], cpio, devio [armeb armel], slugimage (>= 0.10+r58-6) [armeb armel], uboot-mkimage [armel], redboot-tools (>= 0.6) [arm armel], syslinux (>= 2:3.63+dfsg-2) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc], genisovh [mips], tip22 [mips], colo [mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], redboot-imx51-babbage [arm armel], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sparc], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-rescue-efi-amd64 [amd64], grub-common [amd64]
+Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc sparc64], hfsutils [powerpc], dosfstools [i386 ia64 m68k amd64], cpio, devio [armeb armel], slugimage (>= 0.10+r58-6) [armeb armel], u-boot-tools [armel], redboot-tools (>= 0.6) [arm armel], syslinux (>= 2:4.02) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc sparc64], genisovh [mips], tip22 [mips], colo [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], redboot-imx51-babbage [arm armel], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-rescue-efi-amd64 [amd64], grub-common [amd64], debian-ports-archive-keyring [sh4 sparc64]
 # This package has the worst Build-Depends in Debian, so it deserves some
 # explanation. Note that this comment can also be used to generate a
 # Build-Depends line, by running the debian/genbuilddeps program.
@@ -77,7 +77,7 @@
 #		We use mklibs for library reduction.
 #	- genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x]
 #		For making mini isos.
-#	- genromfs [sparc]
+#	- genromfs [sparc sparc64]
 #		Used for creating sparc floppies (which are not built by
 #		default.)
 #	- hfsutils [powerpc]
@@ -94,7 +94,7 @@
 #		kernels and add nslu2 boot magic.
 #	- slugimage (>= 0.10+r58-6) [armeb armel]
 #		For building nslu2 firmware images.
-#	- uboot-mkimage [armel]
+#	- u-boot-tools [armel]
 #		For creating u-boot images
 #	- redboot-tools (>= 0.6) [arm armel]
 #		For creating redboot SD card images for imx51 babbage boards
@@ -103,8 +103,8 @@
 #	On many arches boot loaders are copied onto or ran on the boot
 #	images in one way or another. There's a reason our mailing list is
 #	still called debian-boot..
-#	- syslinux (>= 2:3.63+dfsg-2) [i386 amd64]
-#		With menu default64 support.		
+#	- syslinux (>= 2:4.02) [i386 amd64]
+#		With isohybrid.
 #	- palo [hppa]
 #	- elilo [ia64]
 #	- yaboot [powerpc]
@@ -115,7 +115,7 @@
 #		Using silo is problimatic since it needs to run as root,
 #		so images that need it are not built by default, but we
 #		include it for completeness.
-#	- sparc-utils [sparc]
+#	- sparc-utils [sparc sparc64]
 #		For elftoaout and piggyback, to make netboot images.
 #	- genisovh [mips]
 #		Makes mini iso images bootable on SGI MIPSen.
@@ -123,6 +123,8 @@
 #		Piggyback netboot images.
 #	- colo [mipsel]
 #		For booting Cobalt machines.
+#	- sibyl [mips mipsel]
+# 		For booting the SWARM board.
 #	- atari-bootstrap [m68k]
 #		Booting and other tools for Atari systems.
 #	- vmelilo [m68k]
@@ -149,7 +151,7 @@
 #	- python [i386 amd64]
 #		For building gfxboot help texts.
 #
-#	- module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sparc]
+#	- module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64]
 #		depmod for 2.6 kernels on the arches that support 2.6.
 #
 #	- bf-utf-source [!s390 !s390x]
@@ -165,10 +167,14 @@
 #		Used to create an UFS1 filesystem from a directory tree.
 #	- grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386]
 #		Used as the CD-ROM's bootloader
+#       - xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386]
+#               Used by grub-pc to create the CD-ROM images
 #	- grub-rescue-efi-amd64 [amd64]
 #		EFI bootloader support.
 #	- grub-common [amd64]
 #		For the GRUB font.
+#	- debian-ports-archive-keyring [sh4 sparc64]
+#		Used for architectures hosted on debian-ports.org
 
 Package: debian-installer
 Architecture: any
